## carla 2.5.9

=== Makefile ===
#!/usr/bin/make -f
# Makefile for Carla #
# ------------------ #
# Created by falkTX
#

CWD=source
include source/Makefile.mk

# ---------------------------------------------------------------------------------------------------------------------

PREFIX     := /usr/local
BINDIR     := $(PREFIX)/bin
LIBDIR     := $(PREFIX)/lib
DATADIR    := $(PREFIX)/share
INCLUDEDIR := $(PREFIX)/include
DESTDIR    :=

ifeq ($(DEBUG),true)
MODULEDIR := $(CURDIR)/build/modules/Debug
else
MODULEDIR := $(CURDIR)/build/modules/Release
endif

# see also source/frontend/carla_shared.py and source/includes/CarlaDefines.h
VERSION   := 2.5.9

-include Makefile.user.mk

# ---------------------------------------------------------------------------------------------------------------------

all: backend discovery bridges-plugin bridges-ui frontend interposer libjack plugin theme

# ---------------------------------------------------------------------------------------------------------------------
# Binaries (native)

ifneq ($(STATIC_PLUGIN_TARGET),true)
ALL_LIBS += $(MODULEDIR)/carla_engine.a
endif
ALL_LIBS += $(MODULEDIR)/carla_engine_plugin.a
ALL_LIBS += $(MODULEDIR)/carla_plugin.a
ALL_LIBS += $(MODULEDIR)/jackbridge.a
ifeq ($(STATIC_PLUGIN_TARGET),true)
ALL_LIBS += $(MODULEDIR)/jackbridge.min.a
endif
ALL_LIBS += $(MODULEDIR)/native-plugins.a
ALL_LIBS += $(MODULEDIR)/rtmempool.a

3RD_LIBS += $(MODULEDIR)/audio_decoder.a
3RD_LIBS += $(MODULEDIR)/lilv.a
3RD_LIBS += $(MODULEDIR)/sfzero.a
3RD_LIBS += $(MODULEDIR)/water.a
3RD_LIBS += $(MODULEDIR)/zita-resampler.a

ifeq ($(HAVE_DGL),true)
ifneq ($(USING_CUSTOM_DPF),true)
3RD_LIBS += $(MODULEDIR)/dgl.a
endif
endif

ifeq ($(HAVE_HYLIA),true)
3RD_LIBS += $(MODULEDIR)/hylia.a
endif

ifeq ($(HAVE_QT4),true)
3RD_LIBS += $(MODULEDIR)/theme.qt4.a
endif

ifeq ($(HAVE_QT5),true)
3RD_LIBS += $(MODULEDIR)/theme.qt5.a
endif

ifeq ($(USING_JUCE),true)
3RD_LIBS += $(MODULEDIR)/carla_juce.a
3RD_LIBS += $(MODULEDIR)/juce_audio_basics.a
ifeq ($(USING_JUCE_AUDIO_DEVICES),true)
3RD_LIBS += $(MODULEDIR)/juce_audio_devices.a
endif
3RD_LIBS += $(MODULEDIR)/juce_audio_processors.a
3RD_LIBS += $(MODULEDIR)/juce_core.a
3RD_LIBS += $(MODULEDIR)/juce_data_structures.a
3RD_LIBS += $(MODULEDIR)/juce_events.a
3RD_LIBS += $(MODULEDIR)/juce_graphics.a
3RD_LIBS += $(MODULEDIR)/juce_gui_basics.a
3RD_LIBS += $(MODULEDIR)/juce_gui_extra.a
endif

ifeq ($(USING_RTAUDIO),true)
3RD_LIBS += $(MODULEDIR)/rtaudio.a
3RD_LIBS += $(MODULEDIR)/rtmidi.a
endif

3RD_LIBS += $(MODULEDIR)/ysfx.a

ALL_LIBS += $(3RD_LIBS)

3rd: $(3RD_LIBS)
	@$(MAKE) -C source/theme
ifeq ($(HAVE_QT4),true)
	@$(MAKE) -C source/bridges-ui ui_lv2-qt4
endif

libs: $(ALL_LIBS)

$(MODULEDIR)/carla_engine.a: .FORCE
	@$(MAKE) -C source/backend/engine

$(MODULEDIR)/carla_engine_plugin.a: $(MODULEDIR)/carla_engine.a
	@$(MAKE) -C source/backend/engine

$(MODULEDIR)/carla_plugin.a: .FORCE
	@$(MAKE) -C source/backend/plugin

$(MODULEDIR)/jackbridge.a: .FORCE
	@$(MAKE) -C source/jackbridge

$(MODULEDIR)/jackbridge.%.a: $(MODULEDIR)/jackbridge.a
	@$(MAKE) -C source/jackbridge $*

$(MODULEDIR)/native-plugins.a: .FORCE
	@$(MAKE) -C source/native-plugins

$(MODULEDIR)/theme.qt4.a: .FORCE
	@$(MAKE) -C source/theme qt4

$(MODULEDIR)/theme.qt5.a: .FORCE
	@$(MAKE) -C source/theme qt5

$(MODULEDIR)/%.arm32.a: .FORCE
ifneq ($(WINDOWS),true)
	@$(MAKE) -C source/modules/$* arm32
else
	$(error Trying to build ARM binaries with a Windows toolchain, this cannot work)
endif

$(MODULEDIR)/%.posix32.a: .FORCE
ifneq ($(WINDOWS),true)
	@$(MAKE) -C source/modules/$* posix32
else
	$(error Trying to build POSIX binaries with a Windows toolchain, this cannot work)
endif

$(MODULEDIR)/%.posix64.a: .FORCE
ifneq ($(WINDOWS),true)
	@$(MAKE) -C source/modules/$* posix64
else
	$(error Trying to build POSIX binaries with a Windows toolchain, this cannot work)
endif

$(MODULEDIR)/%.win32.a: .FORCE
ifeq ($(WINDOWS),true)
	@$(MAKE) -C source/modules/$* win32
else
	$(error Trying to build Windows binaries with a regular toolchain, this cannot work)
endif

$(MODULEDIR)/%.win64.a: .FORCE
ifeq ($(WINDOWS),true)
	@$(MAKE) -C source/modules/$* win64
else
	$(error Trying to build Windows binaries with a regular toolchain, this cannot work)
endif

$(MODULEDIR)/dgl.wine.a: .FORCE
	@$(MAKE) -C source/modules/dgl wine

$(MODULEDIR)/water.files.a: .FORCE
	@$(MAKE) -C source/modules/water files

$(MODULEDIR)/%.a: .FORCE
	@$(MAKE) -C source/modules/$*

# ---------------------------------------------------------------------------------------------------------------------

backend: libs
	@$(MAKE) -C source/backend

bridges-plugin: libs
	@$(MAKE) -C source/bridges-plugin

bridges-ui: libs
	@$(MAKE) -C source/bridges-ui

discovery: libs
	@$(MAKE) -C source/discovery

frontend: libs
ifeq ($(HAVE_PYQT),true)
	@$(MAKE) -C source/frontend
endif

interposer:
ifeq ($(LINUX),true)
	@$(MAKE) -C source/interposer
endif

libjack: libs
	@$(MAKE) -C source/libjack

lv2-bundles-dep: $(MODULEDIR)/audio_decoder.a $(MODULEDIR)/water.a $(MODULEDIR)/zita-resampler.a
	@$(MAKE) -C source/native-plugins bundles

lv2-bundles: lv2-bundles-dep
	@$(MAKE) -C source/plugin bundles

plugin: backend bridges-plugin bridges-ui discovery
	@$(MAKE) -C source/plugin

ifeq ($(WINDOWS),true)
plugin-wine:
	@$(MAKE) -C source/plugin wine
else
plugin-wine: $(MODULEDIR)/dgl.wine.a
	@$(MAKE) -C source/plugin wine
endif

rest: libs
	@$(MAKE) -C source/rest

theme: libs
	@$(MAKE) -C source/theme

# ---------------------------------------------------------------------------------------------------------------------
# static targets

static-backend: libs
	@$(MAKE) -C source/backend static

static-plugin: static-backend
	@$(MAKE) -C source/plugin static

# ---------------------------------------------------------------------------------------------------------------------
# hacks

msys2fix:
	rm -rf source/includes/serd
	rm -rf source/includes/sord
	rm -rf source/includes/sratom
	rm -rf source/includes/lilv
	cp -r source/modules/lilv/serd-0.24.0/serd source/includes/serd
	cp -r source/modules/lilv/sord-0.16.0/sord source/includes/sord
	cp -r source/modules/lilv/sratom-0.6.0/sratom source/includes/sratom
	cp -r source/modules/lilv/lilv-0.24.0/lilv source/includes/lilv

# ---------------------------------------------------------------------------------------------------------------------
# Binaries (arm32)

LIBS_ARM32  = $(MODULEDIR)/jackbridge.arm32.a
LIBS_ARM32 += $(MODULEDIR)/lilv.arm32.a
LIBS_ARM32 += $(MODULEDIR)/rtmempool.arm32.a
LIBS_ARM32 += $(MODULEDIR)/water.arm32.a

arm32: $(LIBS_ARM32)
	$(MAKE) -C source/bridges-plugin arm32
	$(MAKE) -C source/discovery arm32

# ---------------------------------------------------------------------------------------------------------------------
# Binaries (posix32)

LIBS_POSIX32  = $(MODULEDIR)/jackbridge.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/lilv.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/rtmempool.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/water.posix32.a

ifeq ($(USING_JUCE),true)
LIBS_POSIX32 += $(MODULEDIR)/carla_juce.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/juce_audio_basics.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/juce_audio_processors.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/juce_data_structures.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/juce_core.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/juce_events.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/juce_graphics.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/juce_gui_basics.posix32.a
LIBS_POSIX32 += $(MODULEDIR)/juce_gui_extra.posix32.a
endif

posix32: $(LIBS_POSIX32)
	$(MAKE) -C source/bridges-plugin posix32
	$(MAKE) -C source/discovery posix32

# ---------------------------------------------------------------------------------------------------------------------
# Binaries (posix64)

LIBS_POSIX64  = $(MODULEDIR)/jackbridge.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/lilv.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/rtmempool.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/water.posix64.a

ifeq ($(USING_JUCE),true)
LIBS_POSIX64 += $(MODULEDIR)/carla_juce.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/juce_audio_basics.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/juce_audio_processors.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/juce_data_structures.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/juce_core.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/juce_events.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/juce_graphics.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/juce_gui_basics.posix64.a
LIBS_POSIX64 += $(MODULEDIR)/juce_gui_extra.posix64.a
endif

posix64: $(LIBS_POSIX64)
	$(MAKE) -C source/bridges-plugin posix64
	$(MAKE) -C source/discovery posix64

# ---------------------------------------------------------------------------------------------------------------------
# Binaries (win32)

LIBS_WIN32 += $(MODULEDIR)/lilv.win32.a
LIBS_WIN32 += $(MODULEDIR)/rtmempool.win32.a
LIBS_WIN32 += $(MODULEDIR)/water.win32.a

ifeq ($(USING_JUCE),true)
LIBS_WIN32 += $(MODULEDIR)/carla_juce.win32.a
LIBS_WIN32 += $(MODULEDIR)/juce_audio_basics.win32.a
LIBS_WIN32 += $(MODULEDIR)/juce_audio_processors.win32.a
LIBS_WIN32 += $(MODULEDIR)/juce_data_structures.win32.a
LIBS_WIN32 += $(MODULEDIR)/juce_core.win32.a
LIBS_WIN32 += $(MODULEDIR)/juce_events.win32.a
LIBS_WIN32 += $(MODULEDIR)/juce_graphics.win32.a
LIBS_WIN32 += $(MODULEDIR)/juce_gui_basics.win32.a
LIBS_WIN32 += $(MODULEDIR)/juce_gui_extra.win32.a
endif

LIBS_WINE32 = $(LIBS_WIN32) $(MODULEDIR)/jackbridge.win32e.a
LIBS_RWIN32 = $(LIBS_WIN32) $(MODULEDIR)/jackbridge.win32.a

ifeq ($(CC),x86_64-w64-mingw32-gcc)
win32:
	$(MAKE) AR=i686-w64-mingw32-ar CC=i686-w64-mingw32-gcc CXX=i686-w64-mingw32-g++ win32-i686

win32r:
	$(MAKE) AR=i686-w64-mingw32-ar CC=i686-w64-mingw32-gcc CXX=i686-w64-mingw32-g++ win32r-i686
else
win32: win32-i686
win32r: win32r-i686
endif

win32-i686: $(LIBS_WINE32)
	$(MAKE) BUILDING_FOR_WINE=true -C source/bridges-plugin win32
	$(MAKE) BUILDING_FOR_WINE=true -C source/discovery win32

win32r-i686: $(LIBS_RWIN32)
	$(MAKE) -C source/bridges-plugin win32
	$(MAKE) -C source/discovery win32

# ---------------------------------------------------------------------------------------------------------------------
# Binaries (win64)

LIBS_WIN64 += $(MODULEDIR)/lilv.win64.a
LIBS_WIN64 += $(MODULEDIR)/rtmempool.win64.a
LIBS_WIN64 += $(MODULEDIR)/water.win64.a

ifeq ($(USING_JUCE),true)
LIBS_WIN64 += $(MODULEDIR)/carla_juce.win64.a
LIBS_WIN64 += $(MODULEDIR)/juce_audio_basics.win64.a
LIBS_WIN64 += $(MODULEDIR)/juce_audio_processors.win64.a
LIBS_WIN64 += $(MODULEDIR)/juce_data_structures.win64.a
LIBS_WIN64 += $(MODULEDIR)/juce_core.win64.a
LIBS_WIN64 += $(MODULEDIR)/juce_events.win64.a
LIBS_WIN64 += $(MODULEDIR)/juce_graphics.win64.a
LIBS_WIN64 += $(MODULEDIR)/juce_gui_basics.win64.a
LIBS_WIN64 += $(MODULEDIR)/juce_gui_extra.win64.a
endif

LIBS_WINE64 = $(LIBS_WIN64) $(MODULEDIR)/jackbridge.win64e.a
LIBS_RWIN64 = $(LIBS_WIN64) $(MODULEDIR)/jackbridge.win64.a

win64: $(LIBS_WINE64)
	$(MAKE) BUILDING_FOR_WINE=true -C source/bridges-plugin win64
	$(MAKE) BUILDING_FOR_WINE=true -C source/discovery win64

win64r: $(LIBS_RWIN64)
ifeq ($(CC),i686-w64-mingw32-gcc)
	$(MAKE) CC=x86_64-w64-mingw32-gcc CXX=x86_64-w64-mingw32-g++ -C source/bridges-plugin win64
	$(MAKE) CC=x86_64-w64-mingw32-gcc CXX=x86_64-w64-mingw32-g++ -C source/discovery win64
else
	$(MAKE) -C source/bridges-plugin win64
	$(MAKE) -C source/discovery win64
endif

# ---------------------------------------------------------------------------------------------------------------------
# Binaries (wine)

wine32:
	$(MAKE) -C source/jackbridge wine32
	cp -f $(MODULEDIR)/jackbridge-wine32.dll$(LIB_EXT) $(CURDIR)/bin/jackbridge-wine32.dll

wine64:
	$(MAKE) -C source/jackbridge wine64
	cp -f $(MODULEDIR)/jackbridge-wine64.dll$(LIB_EXT) $(CURDIR)/bin/jackbridge-wine64.dll

# ---------------------------------------------------------------------------------------------------------------------

clean:
	$(MAKE) clean -C source/backend
	$(MAKE) clean -C source/bridges-plugin
	$(MAKE) clean -C source/bridges-ui
	$(MAKE) clean -C source/jackbridge

=== source/frontend/Makefile ===
#!/usr/bin/make -f
# Makefile for carla-frontend #
# --------------------------- #
# Created by falkTX
#

CWD=..
include $(CWD)/Makefile.mk

# ---------------------------------------------------------------------------------------------------------------------

BINDIR := $(CWD)/../bin
RESDIR := $(CWD)/../resources

# ---------------------------------------------------------------------------------------------------------------------
# Translations

TSs = $(patsubst %,translations/carla_%.ts,$(I18N_LANGUAGES))
QMs = $(patsubst %,translations/carla_%.qm,$(I18N_LANGUAGES))

# ---------------------------------------------------------------------------------------------------------------------
# Resources

RES = \
	resources_rc.py \
	$(BINDIR)/resources/modgui \
	$(BINDIR)/resources/patchcanvas \
	$(BINDIR)/resources/widgets \
	$(BINDIR)/resources/bigmeter-ui \
	$(BINDIR)/resources/carla-plugin \
	$(BINDIR)/resources/carla-plugin-patchbay \
	$(BINDIR)/resources/carla_app.py \
	$(BINDIR)/resources/carla_backend.py \
	$(BINDIR)/resources/carla_backend_qt.py \
	$(BINDIR)/resources/carla_database.py \
	$(BINDIR)/resources/carla_host.py \
	$(BINDIR)/resources/carla_host_control.py \
	$(BINDIR)/resources/carla_modgui.py \
	$(BINDIR)/resources/carla_settings.py \
	$(BINDIR)/resources/carla_skin.py \
	$(BINDIR)/resources/carla_shared.py \
	$(BINDIR)/resources/carla_utils.py \
	$(BINDIR)/resources/carla_widgets.py \
	$(BINDIR)/resources/externalui.py \
	$(BINDIR)/resources/midipattern-ui \
	$(BINDIR)/resources/notes-ui \
	$(BINDIR)/resources/xycontroller-ui \
	$(BINDIR)/resources/resources_rc.py \
	$(BINDIR)/resources/ui_carla_about.py \
	$(BINDIR)/resources/ui_carla_about_juce.py \
	$(BINDIR)/resources/ui_carla_add_jack.py \
	$(BINDIR)/resources/ui_carla_database.py \
	$(BINDIR)/resources/ui_carla_edit.py \
	$(BINDIR)/resources/ui_carla_host.py \
	$(BINDIR)/resources/ui_carla_osc_connect.py \
	$(BINDIR)/resources/ui_carla_parameter.py \
	$(BINDIR)/resources/ui_carla_plugin_calf.py \
	$(BINDIR)/resources/ui_carla_plugin_classic.py \
	$(BINDIR)/resources/ui_carla_plugin_compact.py \
	$(BINDIR)/resources/ui_carla_plugin_default.py \
	$(BINDIR)/resources/ui_carla_plugin_presets.py \
	$(BINDIR)/resources/ui_carla_refresh.py \
	$(BINDIR)/resources/ui_carla_settings.py \
	$(BINDIR)/resources/ui_carla_settings_driver.py \
	$(BINDIR)/resources/ui_inputdialog_value.py \
	$(BINDIR)/resources/ui_midipattern.py \
	$(BINDIR)/resources/ui_xycontroller.py

ifneq ($(SKIP_ZYN_SYNTH),true)
ifeq ($(HAVE_ZYN_UI_DEPS),true)
RES += \
	$(BINDIR)/resources/zynaddsubfx \
	$(BINDIR)/resources/zynaddsubfx-ui
endif
endif

# ---------------------------------------------------------------------------------------------------------------------
# UI code

UIs = \
	ui_carla_about.py \
	ui_carla_about_juce.py \
	ui_carla_add_jack.py \
	ui_carla_database.py \
	ui_carla_edit.py \
	ui_carla_host.py \
	ui_carla_osc_connect.py \
	ui_carla_parameter.py \
	ui_carla_plugin_calf.py \
	ui_carla_plugin_classic.py \
	ui_carla_plugin_compact.py \
	ui_carla_plugin_default.py \
	ui_carla_plugin_presets.py \
	ui_carla_refresh.py \
	ui_carla_settings.py \
	ui_carla_settings_driver.py \
	ui_inputdialog_value.py \
	ui_midipattern.py \
	ui_xycontroller.py

# ---------------------------------------------------------------------------------------------------------------------

all: $(QMs) $(RES) $(UIs)

# ---------------------------------------------------------------------------------------------------------------------

ui_%.py: $(RESDIR)/ui/%.ui
	$(PYUIC) $< -o $@

resources_rc.py: $(RESDIR)/resources.qrc $(RESDIR)/*/*.png $(RESDIR)/*/*.svg $(RESDIR)/*/*.svgz
	$(PYRCC) $< -o $@

$(BINDIR)/resources/%: %
	-@mkdir -p $(BINDIR)/resources
	$(LINK) $(CURDIR)/$* $(BINDIR)/resources/

$(BINDIR)/resources/zynaddsubfx: ../native-plugins/resources/zynaddsubfx
	-@mkdir -p $(BINDIR)/resources
	$(LINK) $(CURDIR)/$< $(BINDIR)/resources/

$(BINDIR)/resources/zynaddsubfx-ui: ../native-plugins/resources/zynaddsubfx-ui
	-@mkdir -p $(BINDIR)/resources
	$(LINK) $(CURDIR)/$< $(BINDIR)/resources/

# ---------------------------------------------------------------------------------------------------------------------

clean:
	rm -rf $(UIs) $(RES) $(QMs) __pycache__ *.pyc

debug:
	$(MAKE) DEBUG=true

# ---------------------------------------------------------------------------------------------------------------------

lint:
	pylint \
	--extension-pkg-whitelist=PyQt5 \
	--max-line-length=120 \
	--max-locals=25 \
	--max-statements=100 \
	--disable=bare-except,duplicate-code,invalid-name,missing-docstring,too-many-branches,too-many-instance-attributes,too-many-statements \
	$(wildcard widgets/*.py)

# ---------------------------------------------------------------------------------------------------------------------

i18n_update: $(TSs)
i18n_release: $(QMs)

translations/%.ts:
	@install -d translations
	pylupdate5 *.py $(RESDIR)/ui/*.ui -ts $@

%.qm: %.ts
	lrelease $< -qm $@

# ---------------------------------------------------------------------------------------------------------------------

=== source/native-plugins/Makefile ===
#!/usr/bin/make -f
# Makefile for native-plugins #
# --------------------------- #
# Created by falkTX
#

CWD=..
CWDE=..
MODULENAME=native-plugins
include ../modules/Makefile.mk

# ---------------------------------------------------------------------------------------------------------------------

BUILD_C_FLAGS   += -I..
BUILD_CXX_FLAGS += -I.. -I$(CWD)/modules

ifneq ($(HAIKU),true)
ifneq ($(WASM),true)
BUILD_CXX_FLAGS += -pthread
endif
endif

# ---------------------------------------------------------------------------------------------------------------------
# Set targets

TARGETS = $(MODULEDIR)/$(MODULENAME).a

BUNDLES = \
	$(MODULEDIR)/$(MODULENAME)_audiogain.a \
	$(MODULEDIR)/$(MODULENAME)_files.a \
	$(MODULEDIR)/$(MODULENAME)_miditools.a

# ---------------------------------------------------------------------------------------------------------------------
# Set objects

OBJS = \
	$(OBJDIR)/_all.c.o \
	$(OBJDIR)/_data.cpp.o \
	$(OBJDIR)/audio-gain.c.o \
	$(OBJDIR)/bypass.c.o \
	$(OBJDIR)/cv-to-audio.c.o \
	$(OBJDIR)/lfo.c.o \
	$(OBJDIR)/midi-channel-filter.c.o \
	$(OBJDIR)/midi-channel-ab.c.o \
	$(OBJDIR)/midi-channelize.c.o \
	$(OBJDIR)/midi-gain.c.o \
	$(OBJDIR)/midi-join.c.o \
	$(OBJDIR)/midi-split.c.o \
	$(OBJDIR)/midi-to-cv.c.o \
	$(OBJDIR)/midi-through.c.o \
	$(OBJDIR)/midi-transpose.c.o \
	$(OBJDIR)/audio-file.cpp.o \
	$(OBJDIR)/bigmeter.cpp.o \
	$(OBJDIR)/midi-file.cpp.o \
	$(OBJDIR)/midi-pattern.cpp.o \
	$(OBJDIR)/notes.cpp.o \
	$(OBJDIR)/xycontroller.cpp.o

OBJS_audiogain = \
	$(OBJDIR)/audio-gain.c.o

OBJS_files = \
	$(OBJDIR)/audio-file.cpp.o \
	$(OBJDIR)/midi-file.cpp.o

OBJS_miditools = \
	$(OBJDIR)/midi-channel-filter.c.o \
	$(OBJDIR)/midi-channel-ab.c.o \
	$(OBJDIR)/midi-channelize.c.o \
	$(OBJDIR)/midi-gain.c.o \
	$(OBJDIR)/midi-join.c.o \
	$(OBJDIR)/midi-split.c.o \
	$(OBJDIR)/midi-transpose.c.o

# ---------------------------------------------------------------------------------------------------------------------
# Include external plugins, if present

ifeq ($(EXTERNAL_PLUGINS),true)
ifneq (,$(wildcard external/Makefile.mk2))
include external/Makefile.mk2
else
$(error External plugins build requested but submodule not present, cannot build)
endif
endif

# ---------------------------------------------------------------------------------------------------------------------

all: $(TARGETS)
bundles: $(BUNDLES)

# ---------------------------------------------------------------------------------------------------------------------

clean:
	rm -f $(OBJDIR)/*.o $(MODULEDIR)/$(MODULENAME)*.a $(ZYN_UI_FILES_H) $(ZYN_UI_FILES_CPP) $(TARGETS)

debug:
	$(MAKE) DEBUG=true

# ---------------------------------------------------------------------------------------------------------------------

$(MODULEDIR)/$(MODULENAME).a: $(OBJS)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME).a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

$(MODULEDIR)/$(MODULENAME)_audiogain.a: $(OBJS_audiogain)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME)_audiogain.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

$(MODULEDIR)/$(MODULENAME)_files.a: $(OBJS_files)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME)_files.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

$(MODULEDIR)/$(MODULENAME)_miditools.a: $(OBJS_miditools)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME)_miditools.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

# ---------------------------------------------------------------------------------------------------------------------

$(OBJDIR)/%.c.o: %.c
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $<"
	$(SILENT)$(CC) $< $(BUILD_C_FLAGS) -c -o $@

$(OBJDIR)/%.cpp.o: %.cpp
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $<"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) -c -o $@

# ---------------------------------------------------------------------------------------------------------------------

-include $(OBJS:%.o=%.d)

# ---------------------------------------------------------------------------------------------------------------------

=== source/plugin/Makefile ===
#!/usr/bin/make -f
# Makefile for carla-plugin #
# ------------------------- #
# Created by falkTX
#

CWD=..
include $(CWD)/Makefile.mk

# Workaround GCC bug
ifeq ($(TESTBUILD),true)
ifeq ($(USING_JUCE),true)
BUILD_CXX_FLAGS += -Wno-undef
endif
endif

ifneq ($(HAIKU),true)
ifneq ($(WASM),true)
BUILD_CXX_FLAGS += -pthread
endif
endif

# ---------------------------------------------------------------------------------------------------------------------

BINDIR    := $(CWD)/../bin
DATADIR   := $(CWD)/../data

ifeq ($(DEBUG),true)
OBJDIR    := $(CWD)/../build/plugin/Debug
MODULEDIR := $(CWD)/../build/modules/Debug
else
OBJDIR    := $(CWD)/../build/plugin/Release
MODULEDIR := $(CWD)/../build/modules/Release
endif

ifeq ($(NEEDS_WINE),true)
EXE_WRAPPER ?= wine
endif

# ---------------------------------------------------------------------------------------------------------------------

BUILD_CXX_FLAGS += -I$(CWD)/backend -I$(CWD)/includes -I$(CWD)/modules -I$(CWD)/utils
BUILD_CXX_FLAGS += $(NATIVE_PLUGINS_FLAGS)

ifeq ($(HAVE_LIBLO),true)
BUILD_CXX_FLAGS += $(LIBLO_FLAGS)
endif

ifeq ($(HAVE_FLUIDSYNTH),true)
BUILD_CXX_FLAGS += $(FLUIDSYNTH_FLAGS)
endif

BUILD_CXX_FLAGS += $(YSFX_FLAGS)

ifeq ($(HAVE_X11),true)
BUILD_CXX_FLAGS += $(X11_FLAGS)
endif

# ---------------------------------------------------------------------------------------------------------------------
# Libs

LIBS  = $(MODULEDIR)/carla_engine_plugin.a
LIBS += $(MODULEDIR)/carla_plugin.a
LIBS += $(MODULEDIR)/jackbridge.a

LIBS += $(MODULEDIR)/lilv.a
LIBS += $(MODULEDIR)/rtmempool.a
LIBS += $(MODULEDIR)/water.a

LIBS += $(MODULEDIR)/audio_decoder.a
LIBS += $(MODULEDIR)/native-plugins.a
LIBS += $(MODULEDIR)/sfzero.a
LIBS += $(MODULEDIR)/zita-resampler.a

ifeq ($(HAVE_DGL),true)
ifneq ($(USING_CUSTOM_DPF),true)
LIBS += $(MODULEDIR)/dgl.a
else
LIBS += $(CUSTOM_DPF_PATH)/build/libdgl-opengl.a
endif
endif

ifeq ($(HAVE_HYLIA),true)
LIBS += $(MODULEDIR)/hylia.a
endif

ifeq ($(USING_JUCE),true)
LIBS_juce  = $(MODULEDIR)/carla_juce.a
LIBS_juce += $(MODULEDIR)/juce_audio_basics.a
LIBS_juce += $(MODULEDIR)/juce_audio_processors.a
LIBS_juce += $(MODULEDIR)/juce_core.a
LIBS_juce += $(MODULEDIR)/juce_data_structures.a
LIBS_juce += $(MODULEDIR)/juce_events.a
LIBS_juce += $(MODULEDIR)/juce_graphics.a
LIBS_juce += $(MODULEDIR)/juce_gui_basics.a
LIBS_juce += $(MODULEDIR)/juce_gui_extra.a
endif

LIBS += $(MODULEDIR)/ysfx.a

# ---------------------------------------------------------------------------------------------------------------------
# Link flags

NATIVE_LINK_FLAGS  = $(HYLIA_LIBS)
NATIVE_LINK_FLAGS += $(LINK_FLAGS)
NATIVE_LINK_FLAGS += $(JACKBRIDGE_LIBS)
NATIVE_LINK_FLAGS += $(LILV_LIBS)
NATIVE_LINK_FLAGS += $(RTMEMPOOL_LIBS)
NATIVE_LINK_FLAGS += $(WATER_LIBS)
NATIVE_LINK_FLAGS += $(NATIVE_PLUGINS_LIBS)

NATIVE_LINK_FLAGS += $(FLUIDSYNTH_LIBS)
NATIVE_LINK_FLAGS += $(LIBLO_LIBS)
NATIVE_LINK_FLAGS += $(MAGIC_LIBS)
NATIVE_LINK_FLAGS += $(X11_LIBS)

ifeq ($(USING_JUCE),true)
LINK_FLAGS += $(JUCE_AUDIO_BASICS_LIBS)
LINK_FLAGS += $(JUCE_AUDIO_PROCESSORS_LIBS)
LINK_FLAGS += $(JUCE_CORE_LIBS)
LINK_FLAGS += $(JUCE_DATA_STRUCTURES_LIBS)
LINK_FLAGS += $(JUCE_EVENTS_LIBS)
LINK_FLAGS += $(JUCE_GRAPHICS_LIBS)
LINK_FLAGS += $(JUCE_GUI_BASICS_LIBS)
LINK_FLAGS += $(JUCE_GUI_EXTRA_LIBS)
endif

LINK_FLAGS += $(YSFX_GRAPHICS_LIBS)

ifeq ($(MACOS),true)
SYMBOLS_NATIVE  = -Wl,-exported_symbol,_carla_get_native_rack_plugin
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_native_patchbay_plugin
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_native_patchbay16_plugin
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_native_patchbay32_plugin
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_native_patchbay64_plugin
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_native_patchbay_cv_plugin
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_native_patchbay_cv8_plugin
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_native_patchbay_cv32_plugin
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_native_patchbay_obs_plugin
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_create_native_plugin_host_handle
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_host_handle_free
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_native_plugin_engine
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_complete_license_text
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_juce_version
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_supported_file_extensions
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_supported_features
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_library_filename
SYMBOLS_NATIVE += -Wl,-exported_symbol,_carla_get_library_folder
SYMBOLS_LV2     = -Wl,-exported_symbol,_lv2_descriptor
ifeq ($(HAVE_PYQT),true)
SYMBOLS_LV2    += -Wl,-exported_symbol,_lv2ui_descriptor
SYMBOLS_LV2_UI  = -Wl,-exported_symbol,_lv2ui_descriptor
endif
SYMBOLS_VST     = -Wl,-exported_symbol,_VSTPluginMain
else ifeq ($(WASM),true)
SYMBOLS_NATIVE  = -sSIDE_MODULE=2 -sEXPORTED_FUNCTIONS="[
SYMBOLS_NATIVE += 'carla_get_native_rack_plugin',
SYMBOLS_NATIVE += 'carla_get_native_patchbay_plugin',
SYMBOLS_NATIVE += 'carla_get_native_patchbay16_plugin',
SYMBOLS_NATIVE += 'carla_get_native_patchbay32_plugin',
SYMBOLS_NATIVE += 'carla_get_native_patchbay64_plugin',
SYMBOLS_NATIVE += 'carla_get_native_patchbay_cv_plugin',
SYMBOLS_NATIVE += 'carla_get_native_patchbay_cv8_plugin',
SYMBOLS_NATIVE += 'carla_get_native_patchbay_cv32_plugin',
SYMBOLS_NATIVE += 'carla_get_native_patchbay_obs_plugin',
SYMBOLS_NATIVE += 'carla_create_native_plugin_host_handle',
SYMBOLS_NATIVE += 'carla_host_handle_free',
SYMBOLS_NATIVE += 'carla_get_native_plugin_engine',
SYMBOLS_NATIVE += 'carla_get_complete_license_text',
SYMBOLS_NATIVE += 'carla_get_juce_version',
SYMBOLS_NATIVE += 'carla_get_supported_file_extensions',
SYMBOLS_NATIVE += 'carla_get_supported_features',
SYMBOLS_NATIVE += 'carla_get_library_filename',
SYMBOLS_NATIVE += 'carla_get_library_folder'
SYMBOLS_NATIVE += ]"
ifeq ($(HAVE_PYQT),true)
SYMBOLS_LV2     = -sSIDE_MODULE=2 -sEXPORTED_FUNCTIONS="['lv2_descriptor','lv2ui_descriptor']"
SYMBOLS_LV2_UI  = -sSIDE_MODULE=2 -sEXPORTED_FUNCTIONS="['lv2ui_descriptor']"
else
SYMBOLS_LV2     = -sSIDE_MODULE=2 -sEXPORTED_FUNCTIONS="['lv2_descriptor']"
endif
SYMBOLS_VST     = -sSIDE_MODULE=2 -sEXPORTED_FUNCTIONS="['VSTPluginMain']"
else ifeq ($(WINDOWS),true)
SYMBOLS_NATIVE  = symbols/carla-native-plugin.def
SYMBOLS_VST     = symbols/carla-vst.def
ifeq ($(HAVE_PYQT),true)
SYMBOLS_LV2     = symbols/carla-lv2_dsp+ui.def
SYMBOLS_LV2_UI  = symbols/carla-lv2_ui.def
else
SYMBOLS_LV2     = symbols/carla-lv2_dsp.def
endif
else
SYMBOLS_NATIVE = -Wl,--version-script=symbols/carla-native-plugin.version
SYMBOLS_VST    = -Wl,--version-script=symbols/carla-vst.version
ifeq ($(HAVE_PYQT),true)
SYMBOLS_LV2     = -Wl,--version-script=symbols/carla-lv2_dsp+ui.version
SYMBOLS_LV2_UI  = -Wl,--version-script=symbols/carla-lv2_ui.version
else
SYMBOLS_LV2     = -Wl,--version-script=symbols/carla-lv2_dsp.version
endif
endif

# ---------------------------------------------------------------------------------------------------------------------
# Other libs

LIBS_ui = $(MODULEDIR)/water.a

LIBS_wine  = $(MODULEDIR)/dgl.wine.a
LIBS_wine += $(MODULEDIR)/water.files.a

WINE_LINK_FLAGS  = $(LINK_FLAGS)
WINE_LINK_FLAGS += -L$(BINDIR) -lcarla_native-plugin
WINE_LINK_FLAGS += -lstdc++ -lopengl32 -lgdi32 -ldl
WINE_LINK_FLAGS += -Wl,-rpath,/usr/local/lib/carla
WINE_LINK_FLAGS += -Wl,-rpath,/usr/lib/carla

# ---------------------------------------------------------------------------------------------------------------------

TARGETS = \
	$(BINDIR)/libcarla_host-plugin$(LIB_EXT) \
	$(BINDIR)/libcarla_native-plugin$(LIB_EXT)

# sometimes needed for testing:
#	$(BINDIR)/carla-native-plugin$(APP_EXT)

# ---------------------------------------------------------------------------------------------------------------------

ifneq ($(STATIC_PLUGIN_TARGET),true)

TARGETS += \
	$(BINDIR)/carla.lv2/carla$(LIB_EXT)

ifeq ($(HAVE_PYQT),true)
TARGETS += \
	$(BINDIR)/carla.lv2/carla-ui$(LIB_EXT)
endif

ifeq ($(CAN_GENERATE_LV2_TTL),true)
TARGETS += \
	$(BINDIR)/carla.lv2/manifest.ttl
endif

ifneq ($(HAIKU),true)
ifeq ($(HAVE_DGL),true)
ifeq ($(HAVE_PYQT),true)
TARGETS += \
	$(BINDIR)/CarlaRack$(LIB_EXT) \
	$(BINDIR)/CarlaRackFX$(LIB_EXT) \
	$(BINDIR)/CarlaPatchbay$(LIB_EXT) \
	$(BINDIR)/CarlaPatchbay16$(LIB_EXT) \
	$(BINDIR)/CarlaPatchbay32$(LIB_EXT) \
	$(BINDIR)/CarlaPatchbay64$(LIB_EXT) \
	$(BINDIR)/CarlaPatchbayFX$(LIB_EXT) \
	$(BINDIR)/CarlaVstShell$(LIB_EXT) \
	$(BINDIR)/CarlaVstFxShell$(LIB_EXT)
endif
endif
endif

endif # !STATIC_PLUGIN_TARGET

# ---------------------------------------------------------------------------------------------------------------------

all: $(TARGETS)

ifeq ($(WINDOWS),true)
wine: $(BINDIR)/CarlaVstShellBridged.dll $(BINDIR)/CarlaVstFxShellBridged.dll
else
wine: $(BINDIR)/CarlaVstShellBridged.dll.so $(BINDIR)/CarlaVstFxShellBridged.dll.so
endif

static: $(OBJDIR)/carla-host-plugin.cpp.o

# ---------------------------------------------------------------------------------------------------------------------

BUNDLES = audiogain files miditools

bundles: \
	$(BINDIR)/carla-audiogain.lv2/manifest.ttl \
	$(BINDIR)/carla-audiogain.lv2/carla$(LIB_EXT) \
	$(BINDIR)/carla-files.lv2/manifest.ttl \
	$(BINDIR)/carla-files.lv2/carla$(LIB_EXT) \
	$(BINDIR)/carla-miditools.lv2/manifest.ttl \
	$(BINDIR)/carla-miditools.lv2/carla$(LIB_EXT)

BUNDLE_LIBS += $(MODULEDIR)/water.files.a
BUNDLE_LIBS += $(WATER_LIBS)

BUNDLE_FILES_LIBS += $(MODULEDIR)/audio_decoder.a
BUNDLE_FILES_LIBS += $(MODULEDIR)/water.a
BUNDLE_FILES_LIBS += $(MODULEDIR)/zita-resampler.a
BUNDLE_FILES_LIBS += $(AUDIO_DECODER_LIBS)
BUNDLE_FILES_LIBS += $(WATER_LIBS)

# ---------------------------------------------------------------------------------------------------------------------

clean:
	rm -f $(OBJDIR)/*.o $(TARGETS)
	rm -f $(BINDIR)/carla.lv2/*.*
	rm -f $(BINDIR)/carla-lv2-export$(APP_EXT)
	rm -rf $(BINDIR)/carla-*.lv2

debug:
	$(MAKE) DEBUG=true

# ---------------------------------------------------------------------------------------------------------------------

$(BINDIR)/libcarla_host-plugin$(LIB_EXT): $(OBJDIR)/carla-host-plugin.cpp.o $(LIBS) $(LIBS_juce)
	-@mkdir -p $(BINDIR)
	@echo "Linking libcarla-host-plugin$(LIB_EXT)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(LIBS_START) $(LIBS) $(LIBS_juce) $(LIBS_END) $(SHARED) $(NATIVE_LINK_FLAGS) -o $@

# ---------------------------------------------------------------------------------------------------------------------

$(BINDIR)/carla-native-plugin$(APP_EXT): $(OBJDIR)/carla-native-plugin.cpp.o $(LIBS) $(LIBS_juce)
	-@mkdir -p $(BINDIR)
	@echo "Linking carla-native-plugin$(APP_EXT)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(LIBS_START) $(LIBS) $(LIBS_juce) $(LIBS_END) $(NATIVE_LINK_FLAGS) -o $@

$(BINDIR)/libcarla_native-plugin$(LIB_EXT): $(OBJDIR)/carla-native-plugin.cpp.o $(LIBS) $(LIBS_juce)
	-@mkdir -p $(BINDIR)
	@echo "Linking libcarla-native-plugin$(LIB_EXT)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(LIBS_START) $(LIBS) $(LIBS_juce) $(LIBS_END) $(SHARED) $(SYMBOLS_NATIVE) $(NATIVE_LINK_FLAGS) -o $@

# ---------------------------------------------------------------------------------------------------------------------

$(BINDIR)/carla.lv2/carla$(LIB_EXT): $(OBJDIR)/carla-lv2.cpp.o $(LIBS) $(LIBS_juce)
	-@mkdir -p $(BINDIR)/carla.lv2
	@echo "Linking carla.lv2/carla$(LIB_EXT)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(LIBS_START) $(LIBS) $(LIBS_juce) $(LIBS_END) $(SHARED) $(SYMBOLS_LV2) $(NATIVE_LINK_FLAGS) -o $@

$(BINDIR)/carla.lv2/carla-ui$(LIB_EXT): $(OBJDIR)/carla-lv2-ui.cpp.o $(LIBS_ui)
	-@mkdir -p $(BINDIR)/carla.lv2
	@echo "Linking carla.lv2/carla-ui$(LIB_EXT)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(LIBS_START) $(LIBS_ui) $(LIBS_END) $(SHARED) $(SYMBOLS_LV2_UI) $(NATIVE_LINK_FLAGS) -o $@

=== source/modules/audio_decoder/Makefile ===
#!/usr/bin/make -f
# Makefile for audio_decoder #
# -------------------------- #
# Created by falkTX
#

CWD=../..
MODULENAME=audio_decoder
include ../Makefile.mk

# ---------------------------------------------------------------------------------------------------------------------

BUILD_C_FLAGS += -Werror=deprecated-declarations

# ---------------------------------------------------------------------------------------------------------------------

OBJS = \
	$(OBJDIR)/ad_dr_mp3.c.o \
	$(OBJDIR)/ad_ffmpeg.c.o \
	$(OBJDIR)/ad_minimp3.c.o \
	$(OBJDIR)/ad_plugin.c.o \
	$(OBJDIR)/ad_soundfile.c.o

# ---------------------------------------------------------------------------------------------------------------------

all: $(MODULEDIR)/$(MODULENAME).a

# ---------------------------------------------------------------------------------------------------------------------

clean:
	rm -f $(OBJDIR)/*.o $(MODULEDIR)/$(MODULENAME)*.a

debug:
	$(MAKE) DEBUG=true

# ---------------------------------------------------------------------------------------------------------------------

$(MODULEDIR)/$(MODULENAME).a: $(OBJS)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME).a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

# ---------------------------------------------------------------------------------------------------------------------

$(OBJDIR)/ad_ffmpeg.c.o: ad_ffmpeg.c
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $<"
	$(SILENT)$(CC) $< $(BUILD_C_FLAGS) $(FFMPEG_FLAGS) -c -o $@

$(OBJDIR)/ad_soundfile.c.o: ad_soundfile.c
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $<"
	$(SILENT)$(CC) $< $(BUILD_C_FLAGS) $(SNDFILE_FLAGS) -c -o $@

$(OBJDIR)/ad_%.c.o: ad_%.c
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $<"
	$(SILENT)$(CC) $< $(BUILD_C_FLAGS) -c -o $@

-include $(OBJS:%.o=%.d)

# ---------------------------------------------------------------------------------------------------------------------

=== source/modules/juce_audio_basics/Makefile ===
#!/usr/bin/make -f
# Makefile for juce_audio_basics #
# ------------------------------ #
# Created by falkTX
#

CWD=../..
MODULENAME=juce_audio_basics
include ../Makefile.mk

# ---------------------------------------------------------------------------------------------------------------------

BUILD_CXX_FLAGS += $(JUCE_AUDIO_BASICS_FLAGS) -I.. -std=gnu++14

# needed for older mingw, crashes on optimized float operations
ifeq ($(WINDOWS),true)
ifneq (,$(findstring i686,$(TARGET_MACHINE)))
BUILD_CXX_FLAGS += -mpreferred-stack-boundary=2
else
32BIT_FLAGS     += -mpreferred-stack-boundary=2
endif
endif

ifeq ($(WINDOWS),true)
BUILD_CXX_FLAGS += -I../mingw-std-threads
endif

# ---------------------------------------------------------------------------------------------------------------------

ifeq ($(MACOS),true)
OBJS         = $(OBJDIR)/$(MODULENAME).mm.o
OBJS_posix32 = $(OBJDIR)/$(MODULENAME).mm.posix32.o
OBJS_posix64 = $(OBJDIR)/$(MODULENAME).mm.posix64.o
else
OBJS         = $(OBJDIR)/$(MODULENAME).cpp.o
OBJS_posix32 = $(OBJDIR)/$(MODULENAME).cpp.posix32.o
OBJS_posix64 = $(OBJDIR)/$(MODULENAME).cpp.posix64.o
endif
OBJS_win32   = $(OBJDIR)/$(MODULENAME).cpp.win32.o
OBJS_win64   = $(OBJDIR)/$(MODULENAME).cpp.win64.o

# ---------------------------------------------------------------------------------------------------------------------

all:     $(MODULEDIR)/$(MODULENAME).a
posix32: $(MODULEDIR)/$(MODULENAME).posix32.a
posix64: $(MODULEDIR)/$(MODULENAME).posix64.a
win32:   $(MODULEDIR)/$(MODULENAME).win32.a
win64:   $(MODULEDIR)/$(MODULENAME).win64.a

# ---------------------------------------------------------------------------------------------------------------------

clean:
	rm -f $(OBJDIR)/*.o $(MODULEDIR)/$(MODULENAME)*.a

debug:
	$(MAKE) DEBUG=true

# ---------------------------------------------------------------------------------------------------------------------

$(MODULEDIR)/$(MODULENAME).a: $(OBJS)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME).a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

$(MODULEDIR)/$(MODULENAME).posix32.a: $(OBJS_posix32)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME).posix32.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

$(MODULEDIR)/$(MODULENAME).posix64.a: $(OBJS_posix64)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME).posix64.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

$(MODULEDIR)/$(MODULENAME).win32.a: $(OBJS_win32)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME).win32.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

$(MODULEDIR)/$(MODULENAME).win64.a: $(OBJS_win64)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME).win64.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

# ---------------------------------------------------------------------------------------------------------------------

$(OBJDIR)/$(MODULENAME).cpp.o: $(MODULENAME).cpp
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $<"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) -c -o $@

$(OBJDIR)/$(MODULENAME).cpp.%32.o: $(MODULENAME).cpp
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $< (32bit)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(32BIT_FLAGS) -c -o $@

$(OBJDIR)/$(MODULENAME).cpp.%64.o: $(MODULENAME).cpp
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $< (64bit)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(64BIT_FLAGS) -c -o $@

# ---------------------------------------------------------------------------------------------------------------------

$(OBJDIR)/$(MODULENAME).mm.o: $(MODULENAME).cpp
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $<"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) -ObjC++ -c -o $@

$(OBJDIR)/$(MODULENAME).mm.%32.o: $(MODULENAME).cpp
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $< (32bit)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(32BIT_FLAGS) -ObjC++ -c -o $@

$(OBJDIR)/$(MODULENAME).mm.%64.o: $(MODULENAME).cpp
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $< (64bit)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(64BIT_FLAGS) -ObjC++ -c -o $@

# ---------------------------------------------------------------------------------------------------------------------

-include $(OBJS:%.o=%.d)
-include $(OBJS_posix32:%.o=%.d)
-include $(OBJS_posix64:%.o=%.d)
-include $(OBJS_win32:%.o=%.d)
-include $(OBJS_win64:%.o=%.d)

# ---------------------------------------------------------------------------------------------------------------------

=== source/modules/rtaudio/Makefile ===
#!/usr/bin/make -f
# Makefile for rtaudio #
# -------------------- #
# Created by falkTX
#

CWD=../..
MODULENAME=rtaudio
include ../Makefile.mk

# ---------------------------------------------------------------------------------------------------------------------

BUILD_CXX_FLAGS += $(RTAUDIO_FLAGS) -I$(CWD) -Iinclude

ifeq ($(WINDOWS),true)
BUILD_CXX_FLAGS += -Wno-unused-function -Wno-unused-but-set-variable
endif

# ---------------------------------------------------------------------------------------------------------------------

OBJS = $(OBJDIR)/RtAudio.cpp.o

# ---------------------------------------------------------------------------------------------------------------------

all: $(MODULEDIR)/$(MODULENAME).a

# ---------------------------------------------------------------------------------------------------------------------

clean:
	rm -f $(OBJDIR)/*.o $(MODULEDIR)/$(MODULENAME)*.a

debug:
	$(MAKE) DEBUG=true

# ---------------------------------------------------------------------------------------------------------------------

$(MODULEDIR)/$(MODULENAME).a: $(OBJS)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME).a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

# ---------------------------------------------------------------------------------------------------------------------

$(OBJDIR)/%.cpp.o: %.cpp
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $<"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) -c -o $@

-include $(OBJS:%.o=%.d)

# ---------------------------------------------------------------------------------------------------------------------

=== source/modules/rtmidi/Makefile ===
#!/usr/bin/make -f
# Makefile for rtmidi #
# ------------------- #
# Created by falkTX
#

CWD=../..
MODULENAME=rtmidi
include ../Makefile.mk

# ---------------------------------------------------------------------------------------------------------------------

BUILD_CXX_FLAGS += $(RTMIDI_FLAGS) -w

# ---------------------------------------------------------------------------------------------------------------------

OBJS = $(OBJDIR)/RtMidi.cpp.o

# ---------------------------------------------------------------------------------------------------------------------

all: $(MODULEDIR)/$(MODULENAME).a

# ---------------------------------------------------------------------------------------------------------------------

clean:
	rm -f $(OBJDIR)/*.o $(MODULEDIR)/$(MODULENAME)*.a

debug:
	$(MAKE) DEBUG=true

# ---------------------------------------------------------------------------------------------------------------------

$(MODULEDIR)/$(MODULENAME).a: $(OBJS)
	-@mkdir -p $(MODULEDIR)
	@echo "Creating $(MODULENAME).a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

# ---------------------------------------------------------------------------------------------------------------------

$(OBJDIR)/%.cpp.o: %.cpp
	-@mkdir -p $(OBJDIR)
	@echo "Compiling $<"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) -c -o $@

-include $(OBJS:%.o=%.d)

# ---------------------------------------------------------------------------------------------------------------------

=== debian/changelog ===
carla (2.5.9-0ubuntu1) oracular; urgency=medium

  [ Erich Eickmeyer ]
  * New upstream bugfix release 2.5.9
  * Remove obsolete patches
  * Fix obsolete build-deps

  [ Filipe Coelho ]
  * Fix build against latest liblo
  * Fix crash when showing some plugin UIs under wayland
  * Fix minimum width of CanvasPort labels
  * Fix missing painter.restore() in case of CanvasPort errors
  * Fix OSC unregister handling

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Tue, 24 Sep 2024 13:59:01 -0700

carla (2.5.8-0ubuntu6) oracular; urgency=medium

  * Patch for new liblo API (LP: #2077440, 2077450)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Tue, 20 Aug 2024 09:56:32 -0700

=== debian/control ===
Source: carla
Section: sound
Priority: optional
Rules-Requires-Root: no
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
XSBC-Original-Maintainer: falkTX <falktx@gmail.com>
Build-Depends: debhelper-compat (= 13),
  g++-multilib,
  pkgconf,
  pyqt5-dev-tools,
  qtbase5-dev,
  qtbase5-dev-tools,
  libgtk2.0-dev,
  libgtk-3-dev,
  libasound2-dev,
  libpulse-dev,
  libmagic-dev,
  libx11-dev,
  libgl-dev,
  libglu1-mesa-dev | libglu-dev,
  liblo-dev,
  libfftw3-dev,
  libmxml-dev,
  libzlcore-dev,
  libfluidsynth-dev,
  libsndfile1-dev,
  g++-mingw-w64,
  g++-mingw-w64-i686 [amd64],
  libwine-dev,
  mingw-w64,
  wine64-tools | wine32-tools
Build-Conflicts:
  libffi-static,
  glib-static,
  liblo-static,
  fftw3-static,
  mxml-static,
  fluidsynth-static,
  zlib-static
Standards-Version: 4.6.1
Vcs-Git: https://git.launchpad.net/carla
Vcs-Browser: https://git.launchpad.net/carla
Homepage: https://kxstudio.linuxaudio.org/Applications:Carla

Package: carla
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}, carla-data, python3-liblo,
 python3-pyqt5, python3-pyqt5.qtsvg, python3
Recommends: python3-pyqt5.qtopengl, python3-rdflib, carla-lv2, carla-vst
Description: audio plugin host
 Carla is an audio plugin host, with support for many audio drivers and plugin
 formats. It has some nice features like automation of parameters via MIDI CC
 and full OSC control. Currently supports LADSPA, DSSI, LV2, VST2/3 and AU
 plugin formats, plus SF2 and SFZ sounds banks.
 .
 This package contains the main application.

Package: carla-dev
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: audio plugin host - development libraries
 Carla is an audio plugin host, with support for many audio drivers and plugin
 formats. It has some nice features like automation of parameters via MIDI CC
 and full OSC control. Currently supports LADSPA, DSSI, LV2, VST2/3 and AU
 plugin formats, plus SF2 and SFZ sounds banks.
 .
 This package contains the development libraries.

Package: carla-data
Architecture: all
Depends: ${misc:Depends}
Description: audio plugin host (common data)
 Carla is an audio plugin host, with support for many audio drivers and plugin
 formats. It has some nice features like automation of parameters via MIDI CC
 and full OSC control. Currently supports LADSPA, DSSI, LV2, VST2/3 and AU
 plugin formats, plus SF2 and SFZ sounds banks.
 .
 This package contains common non-binary data.

Package: carla-lv2
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}, carla
Description: audio plugin host (LV2 plugin)
 Carla is an audio plugin host, with support for many audio drivers and plugin
 formats. It has some nice features like automation of parameters via MIDI CC
 and full OSC control. Currently supports LADSPA, DSSI, LV2, VST2/3 and AU
 plugin formats, plus SF2 and SFZ sounds banks.
 .
 This package contains the LV2 plugin.

Package: carla-vst
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}, carla
Description: audio plugin host (VST plugin)
 Carla is an audio plugin host, with support for many audio drivers and plugin
 formats. It has some nice features like automation of parameters via MIDI CC
 and full OSC control. Currently supports LADSPA, DSSI, LV2, VST2/3 and AU
 plugin formats, plus SF2 and SFZ sounds banks.
 .
 This package contains the VST plugin.

Package: carla-bridge-linux32
Architecture: i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: carla
Description: audio plugin host (linux32 bridge)
 Carla is an audio plugin host, with support for many audio drivers and plugin
 formats. It has some nice features like automation of parameters via MIDI CC
 and full OSC control. Currently supports LADSPA, DSSI, LV2, VST2/3 and AU
 plugin formats, plus SF2 and SFZ sounds banks.
 .
 This package provides the linux32 bridge for loading 32bit Linux plugins.

Package: carla-bridge-linux64
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: carla
Description: audio plugin host (linux64 bridge)
 Carla is an audio plugin host, with support for many audio drivers and plugin
 formats. It has some nice features like automation of parameters via MIDI CC
 and full OSC control. Currently supports LADSPA, DSSI, LV2, VST2/3 and AU
 plugin formats, plus SF2 and SFZ sounds banks.
 .
 This package provides the linux64 bridge for loading 64bit Linux plugins.

Package: carla-bridge-wine32
Architecture: i386
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, wine-development | wine-staging |
 wine-stable | wine
Recommends: carla-bridge-win32
Description: carla win32 bridge (wine DLL)
 This package provides the wine DLL needed for the Carla win32 bridge.

Package: carla-bridge-wine64
Architecture: amd64
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, wine-development | wine-staging |
 wine-stable | wine
Recommends: carla-bridge-win64
Description: carla win64 bridge (wine DLL)
 This package provides the wine DLL needed for the Carla win64 bridge.

Package: carla-bridge-win32
Architecture: i386
Multi-Arch: allowed
Depends: ${misc:Depends}, carla-bridge-wine32
Description: carla win32 bridge
 This package provides the Carla win32 bridge.

Package: carla-bridge-win64
Architecture: amd64
Multi-Arch: allowed
Depends: ${misc:Depends}, carla-bridge-wine64
Description: carla win64 bridge
 This package provides the Carla win64 bridge.
